////////////////////////////////////////////////////////////////
// タイマーガジェット
//   Copyright (C) 2008 - 2012 AAOh inc.
////////////////////////////////////////////////////////////////

/**
 * @fileOverview タイマー
 * @author       $Author: fujishiro $
 */

(function () {
/**
 * Option。
 *
 * @constructor
 */
timer.Option = aaoh.kaze.Gadget.extend(
	aaoh.sora.OptionEx, function() {
	this.filter      = null;
	this.filterName1 = null;
	this.filterExt1  = null;
	this.filterName2 = null;
	this.filterExt2  = null;
});
	/**
	 * アラートの設定。
	 */
	timer.Option.prototype.
	setAlert = function() {
		var cbxAlert    = aaoh.kaze.Gadget.$('cbxAlert');
		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		var lblAlertDef = aaoh.kaze.Gadget.$('lblAlertDef');
		var txtAlert    = aaoh.kaze.Gadget.$('txtAlert');

		var isAlert  = aaoh.kaze.Element.isChecked(cbxAlert);
		if (isAlert) {
			aaoh.kaze.Element.setEnabled(cbxAlertDef, true);
			aaoh.kaze.Element.setEnabled(lblAlertDef, true);
			this.setAlertMsg();

		} else {
			aaoh.kaze.Element.setEnabled(cbxAlertDef, false);
			aaoh.kaze.Element.setEnabled(lblAlertDef, false);
			aaoh.kaze.Element.setEnabled(txtAlert,    false);
		}
	}

	/**
	 * アラートの設定。
	 */
	timer.Option.prototype.
	setAlertMsg = function() {
		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		var txtAlert    = aaoh.kaze.Gadget.$('txtAlert');

		var isAlertDef = aaoh.kaze.Element.isChecked(cbxAlertDef);
		if (isAlertDef) {
			aaoh.kaze.Element.setEnabled(txtAlert, false);
			aaoh.kaze.Element.setValue(
				txtAlert, aaoh.sora.App.control.DEFAULT_ALERT_MSG
			);

		} else {
			aaoh.kaze.Element.setEnabled(txtAlert, true);
		}
	}

	/**
	 * 音の設定。
	 */
	timer.Option.prototype.
	setSound = function() {
		var cbxSound      = aaoh.kaze.Gadget.$('cbxSound');
		var cbxSoundDef   = aaoh.kaze.Gadget.$('cbxSoundDef');
		var lblSoundDef   = aaoh.kaze.Gadget.$('lblSoundDef');
		var txtSound      = aaoh.kaze.Gadget.$('txtSound');
		var btnSound      = aaoh.kaze.Gadget.$('btnSound');
		var selSoundVol   = aaoh.kaze.Gadget.$('selSoundVol');
		var btnSoundStart = aaoh.kaze.Gadget.$('btnSoundStart');
		var btnSoundStop  = aaoh.kaze.Gadget.$('btnSoundStop');

		var isSound  = aaoh.kaze.Element.isChecked(cbxSound);
		if (isSound) {
			aaoh.kaze.Element.setEnabled(cbxSoundDef,   true);
			aaoh.kaze.Element.setEnabled(lblSoundDef,   true);
			this.setSoundFile();
			aaoh.kaze.Element.setEnabled(selSoundVol,   true);
			aaoh.kaze.Element.setEnabled(btnSoundStart, true);
			aaoh.kaze.Element.setEnabled(btnSoundStop,  true);

		} else {
			aaoh.kaze.Element.setEnabled(cbxSoundDef,   false);
			aaoh.kaze.Element.setEnabled(lblSoundDef,   false);
			aaoh.kaze.Element.setEnabled(txtSound,      false);
			aaoh.kaze.Element.setEnabled(btnSound,      false);
			aaoh.kaze.Element.setEnabled(selSoundVol,   false);
			aaoh.kaze.Element.setEnabled(btnSoundStart, false);
			aaoh.kaze.Element.setEnabled(btnSoundStop,  false);
		}
	}

	/**
	 * 音の設定。
	 */
	timer.Option.prototype.
	setSoundFile = function() {
		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		var txtSound    = aaoh.kaze.Gadget.$('txtSound');
		var btnSound    = aaoh.kaze.Gadget.$('btnSound');

		var isSoundDef = aaoh.kaze.Element.isChecked(cbxSoundDef);
		if (isSoundDef) {
			aaoh.kaze.Element.setEnabled(txtSound, false);
			aaoh.kaze.Element.setEnabled(btnSound, false);

			var soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;
			aaoh.kaze.Element.setValue(txtSound, soundFile);

		} else {
			aaoh.kaze.Element.setEnabled(txtSound, true);
			aaoh.kaze.Element.setEnabled(btnSound, true);
		} // if (isSoundDef)
	}

	/**
	 * 音源ファイルの選択。
	 */
	timer.Option.prototype.
	browseSoundFile = function() {
		aaoh.kaze.Gadget.browseForFile(
			this.filter,
			this.filterName1, this.filterExt1, this.filterName2, this.filterExt2,
			function(selectFile) {
			var txtSound  = aaoh.kaze.Gadget.$('txtSound');
			aaoh.kaze.Element.setValue(txtSound, selectFile);
		}, this);
	}

	/**
	 * 音源ファイルの再生。
	 */
	timer.Option.prototype.
	soundPlay = function() {
		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		var isSoundDef  = aaoh.kaze.Element.isChecked(cbxSoundDef);

		var soundFile = null;
		if (isSoundDef) {
			soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;

		} else {
			var txtSound  = aaoh.kaze.Gadget.$('txtSound');
			soundFile = aaoh.kaze.Element.getValue(txtSound);
		} // if (isSoundDef)

		if (soundFile != null && soundFile != '') {
			var isSoundVol = aaoh.sora.App.control.sound.isVolume();
			if (isSoundVol) {
				var selSoundVol = aaoh.kaze.Gadget.$('selSoundVol');
				var numSoundVol = parseInt(
					aaoh.kaze.Element.getSelected(selSoundVol), 10
				);

				aaoh.sora.App.control.sound.setVolume(numSoundVol);
			}

			aaoh.sora.App.control.sound.play(soundFile);
		} // if (soundFile != null && soundFile != '')
	}

	/**
	 * 音源ファイルの停止。
	 */
	timer.Option.prototype.
	soundStop = function() {
		aaoh.sora.App.control.sound.stop();
	}

	/**
	 * 設定データの設定。
	 */
	timer.Option.prototype.
	doOption = function() {
		// type
		for (var cnt = 1; cnt <= 6; cnt++) {
			var rdoType = aaoh.kaze.Gadget.$('rdoType' + cnt);
			var flgType = aaoh.kaze.Element.isChecked(rdoType);

			if (flgType) {
				aaoh.sora.App.model.data.type = String(cnt);
				break;
			}
		}

		// mode
		for (var cnt = 1; cnt <= 2; cnt++) {
			var rdoMode = aaoh.kaze.Gadget.$('rdoMode' + cnt);
			var flgMode = aaoh.kaze.Element.isChecked(rdoMode);

			if (flgMode) {
				aaoh.sora.App.model.data.mode = String(cnt);
				break;
			}
		}

		// numTime1
		var selTime1Hour = aaoh.kaze.Gadget.$('selTime1Hour');
		var selTime1Min  = aaoh.kaze.Gadget.$('selTime1Min');
		var selTime1Sec  = aaoh.kaze.Gadget.$('selTime1Sec');
		var numTime1Hour = parseInt(
			aaoh.kaze.Element.getSelected(selTime1Hour), 10
		);
		var numTime1Min = parseInt(
			aaoh.kaze.Element.getSelected(selTime1Min), 10
		);
		var numTime1Sec = parseInt(
			aaoh.kaze.Element.getSelected(selTime1Sec), 10
		);
		aaoh.sora.App.model.data.numTime1
			= aaoh.sora.App.control.getTime(numTime1Hour, numTime1Min, numTime1Sec);

		// numTime2
		var selTime2Hour = aaoh.kaze.Gadget.$('selTime2Hour');
		var selTime2Min  = aaoh.kaze.Gadget.$('selTime2Min');
		var selTime2Sec  = aaoh.kaze.Gadget.$('selTime2Sec');
		var numTime2Hour = parseInt(
			aaoh.kaze.Element.getSelected(selTime2Hour), 10
		);
		var numTime2Min = parseInt(
			aaoh.kaze.Element.getSelected(selTime2Min), 10
		);
		var numTime2Sec = parseInt(
			aaoh.kaze.Element.getSelected(selTime2Sec), 10
		);
		aaoh.sora.App.model.data.numTime2
			= aaoh.sora.App.control.getTime(numTime2Hour, numTime2Min, numTime2Sec);

		// numTime3
		var selTime3Hour = aaoh.kaze.Gadget.$('selTime3Hour');
		var selTime3Min  = aaoh.kaze.Gadget.$('selTime3Min');
		var selTime3Sec  = aaoh.kaze.Gadget.$('selTime3Sec');
		var numTime3Hour = parseInt(
			aaoh.kaze.Element.getSelected(selTime3Hour), 10
		);
		var numTime3Min = parseInt(
			aaoh.kaze.Element.getSelected(selTime3Min), 10
		);
		var numTime3Sec = parseInt(
			aaoh.kaze.Element.getSelected(selTime3Sec), 10
		);
		aaoh.sora.App.model.data.numTime3
			= aaoh.sora.App.control.getTime(numTime3Hour, numTime3Min, numTime3Sec);

		// isAlert
		var cbxAlert = aaoh.kaze.Gadget.$('cbxAlert');
		var isAlert  = aaoh.kaze.Element.isChecked(cbxAlert);
		aaoh.sora.App.model.data.isAlert = isAlert;

		if (isAlert) {
			// isAlertDef
			var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
			var isAlertDef  = aaoh.kaze.Element.isChecked(cbxAlertDef);
			aaoh.sora.App.model.data.isAlertDef = isAlertDef;

			// alertMsg
			if (!isAlertDef) {
				var txtAlert = aaoh.kaze.Gadget.$('txtAlert');
				var alertMsg = aaoh.kaze.Element.getValue(txtAlert);
				aaoh.sora.App.model.data.alertMsg = alertMsg;
			}
		} // if (isAlert)

		// isSound
		var cbxSound = aaoh.kaze.Gadget.$('cbxSound');
		var isSound  = aaoh.kaze.Element.isChecked(cbxSound);
		aaoh.sora.App.model.data.isSound = isSound;

		if (isSound) {
			// isSoundDef
			var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
			var isSoundDef  = aaoh.kaze.Element.isChecked(cbxSoundDef);
			aaoh.sora.App.model.data.isSoundDef = isSoundDef;

			// soundFile
			if (!isSoundDef) {
				var txtSound  = aaoh.kaze.Gadget.$('txtSound');
				var soundFile = aaoh.kaze.Element.getValue(txtSound);
				aaoh.sora.App.model.data.soundFile = soundFile;
			}

			// numSoundVol
			var selSoundVol = aaoh.kaze.Gadget.$('selSoundVol');
			var numSoundVol = parseInt(
				aaoh.kaze.Element.getSelected(selSoundVol), 10
			);
			aaoh.sora.App.model.data.numSoundVol = numSoundVol;
		} // if (isSound)
	}

	/**
	 * 表示データの初期化。
	 */
	timer.Option.prototype.
	initData = function() {
		// デフォルト値の更新
		aaoh.sora.App.control.DEFAULT_ALERT_MSG
			= aaoh.sora.App.control.locale.getString('ALERT_MSG');

		this.initTitleData();
		this.initDefaultData();
	}

	/**
	 * 表示データの初期化(タイトル)。
	 */
	timer.Option.prototype.
	initTitleData = function() {
		var lblType       = aaoh.kaze.Gadget.$('lblType');
		var lblType1      = aaoh.kaze.Gadget.$('lblType1');
		var lblType2      = aaoh.kaze.Gadget.$('lblType2');
		var lblType3      = aaoh.kaze.Gadget.$('lblType3');
		var lblType4      = aaoh.kaze.Gadget.$('lblType4');
		var lblType5      = aaoh.kaze.Gadget.$('lblType5');
		var lblType6      = aaoh.kaze.Gadget.$('lblType6');
		var lblMode       = aaoh.kaze.Gadget.$('lblMode');
		var lblMode1      = aaoh.kaze.Gadget.$('lblMode1');
		var lblMode2      = aaoh.kaze.Gadget.$('lblMode2');
		var lblPreset1    = aaoh.kaze.Gadget.$('lblPreset1');
		var lblPreset2    = aaoh.kaze.Gadget.$('lblPreset2');
		var lblPreset3    = aaoh.kaze.Gadget.$('lblPreset3');
		var lblAlert      = aaoh.kaze.Gadget.$('lblAlert');
		var lblAlertDef   = aaoh.kaze.Gadget.$('lblAlertDef');
		var lblSound      = aaoh.kaze.Gadget.$('lblSound');
		var lblSoundDef   = aaoh.kaze.Gadget.$('lblSoundDef');
		var lblSoundVol   = aaoh.kaze.Gadget.$('lblSoundVol');
		var btnSoundStart = aaoh.kaze.Gadget.$('btnSoundStart');
		var btnSoundStop  = aaoh.kaze.Gadget.$('btnSoundStop');

		var ttlType       = aaoh.sora.App.control.locale.getString('TTL_TYPE');
		var ttlType1      = aaoh.sora.App.control.locale.getString('TTL_TYPE1');
		var ttlType2      = aaoh.sora.App.control.locale.getString('TTL_TYPE2');
		var ttlType3      = aaoh.sora.App.control.locale.getString('TTL_TYPE3');
		var ttlType4      = aaoh.sora.App.control.locale.getString('TTL_TYPE4');
		var ttlType5      = aaoh.sora.App.control.locale.getString('TTL_TYPE5');
		var ttlType6      = aaoh.sora.App.control.locale.getString('TTL_TYPE6');
		var ttlMode       = aaoh.sora.App.control.locale.getString('TTL_MODE');
		var ttlMode1      = aaoh.sora.App.control.locale.getString('TTL_MODE1');
		var ttlMode2      = aaoh.sora.App.control.locale.getString('TTL_MODE2');
		var ttlPreset1    = aaoh.sora.App.control.locale.getString('TTL_PRESET1');
		var ttlPreset2    = aaoh.sora.App.control.locale.getString('TTL_PRESET2');
		var ttlPreset3    = aaoh.sora.App.control.locale.getString('TTL_PRESET3');
		var ttlAlert      = aaoh.sora.App.control.locale.getString('TTL_ALERT');
		var ttlAlertDef   = aaoh.sora.App.control.locale.getString('TTL_ALERT_DEF');
		//var ttlAlertMsg   = aaoh.sora.App.control.locale.getString('TTL_ALERT_MSG');
		var ttlSound      = aaoh.sora.App.control.locale.getString('TTL_SOUND');
		var ttlSoundDef   = aaoh.sora.App.control.locale.getString('TTL_ALERT_DEF');
		//var ttlSoundFile  = aaoh.sora.App.control.locale.getString('TTL_SOUND_FILE');
		var ttlSoundVol   = aaoh.sora.App.control.locale.getString('TTL_SOUND_VOL');
		var ttlSoundStart = aaoh.sora.App.control.locale.getString('TTL_SOUND_START');
		var ttlSoundStop  = aaoh.sora.App.control.locale.getString('TTL_SOUND_STOP');

		aaoh.kaze.Element.setValue(lblType,       ttlType);
		aaoh.kaze.Element.setValue(lblType1,      ttlType1);
		aaoh.kaze.Element.setValue(lblType2,      ttlType2);
		aaoh.kaze.Element.setValue(lblType3,      ttlType3);
		aaoh.kaze.Element.setValue(lblType4,      ttlType4);
		aaoh.kaze.Element.setValue(lblType5,      ttlType5);
		aaoh.kaze.Element.setValue(lblType6,      ttlType6);
		aaoh.kaze.Element.setValue(lblMode,       ttlMode);
		aaoh.kaze.Element.setValue(lblMode1,      ttlMode1);
		aaoh.kaze.Element.setValue(lblMode2,      ttlMode2);
		aaoh.kaze.Element.setValue(lblPreset1,    ttlPreset1);
		aaoh.kaze.Element.setValue(lblPreset2,    ttlPreset2);
		aaoh.kaze.Element.setValue(lblPreset3,    ttlPreset3);
		aaoh.kaze.Element.setValue(lblAlert,      ttlAlert);
		aaoh.kaze.Element.setValue(lblAlertDef,   ttlAlertDef);
		aaoh.kaze.Element.setValue(lblSound,      ttlSound);
		aaoh.kaze.Element.setValue(lblSoundDef,   ttlSoundDef);
		aaoh.kaze.Element.setValue(lblSoundVol,   ttlSoundVol);
		aaoh.kaze.Element.setValue(btnSoundStart, ttlSoundStart);
		aaoh.kaze.Element.setValue(btnSoundStop,  ttlSoundStop);

		this.filter      = aaoh.sora.App.control.locale.getString('SOUND_FILTER');
		this.filterName1 = aaoh.sora.App.control.locale.getString('SOUND_FILTER_NAME1');
		this.filterExt1  = aaoh.sora.App.control.locale.getString('SOUND_FILTER_EXT1');
		this.filterName2 = aaoh.sora.App.control.locale.getString('SOUND_FILTER_NAME2');
		this.filterExt2  = aaoh.sora.App.control.locale.getString('SOUND_FILTER_EXT2');
	}

	/**
	 * 表示データの初期化(デフォルト)。
	 */
	timer.Option.prototype.
	initDefaultData = function() {
		// type
		var rdoType = aaoh.kaze.Gadget.$(
			'rdoType' + aaoh.sora.App.model.data.type
		);
		aaoh.kaze.Element.setChecked(rdoType, true);

		// mode
		var rdoMode = aaoh.kaze.Gadget.$(
			'rdoMode' + aaoh.sora.App.model.data.mode
		);
		aaoh.kaze.Element.setChecked(rdoMode, true);

		// numTime1
		var time1List
			= aaoh.sora.App.control.getShowTime(aaoh.sora.App.model.data.numTime1);
		var selTime1HourItem = aaoh.kaze.Gadget.$(
			'selTime1Hour_' + time1List[0]
		)
		var selTime1MinItem = aaoh.kaze.Gadget.$(
			'selTime1Min_' + time1List[1]
		)
		var selTime1SecItem = aaoh.kaze.Gadget.$(
			'selTime1Sec_' + time1List[2]
		)
		aaoh.kaze.Element.setSelected(selTime1HourItem, true);
		aaoh.kaze.Element.setSelected(selTime1MinItem, true);
		aaoh.kaze.Element.setSelected(selTime1SecItem, true);

		// numTime2
		var time2List
			= aaoh.sora.App.control.getShowTime(aaoh.sora.App.model.data.numTime2);
		var selTime2HourItem = aaoh.kaze.Gadget.$(
			'selTime2Hour_' + time2List[0]
		)
		var selTime2MinItem = aaoh.kaze.Gadget.$(
			'selTime2Min_' + time2List[1]
		)
		var selTime2SecItem = aaoh.kaze.Gadget.$(
			'selTime2Sec_' + time2List[2]
		)
		aaoh.kaze.Element.setSelected(selTime2HourItem, true);
		aaoh.kaze.Element.setSelected(selTime2MinItem, true);
		aaoh.kaze.Element.setSelected(selTime2SecItem, true);

		// numTime3
		var time3List
			= aaoh.sora.App.control.getShowTime(aaoh.sora.App.model.data.numTime3);
		var selTime3HourItem = aaoh.kaze.Gadget.$(
			'selTime3Hour_' + time3List[0]
		)
		var selTime3MinItem = aaoh.kaze.Gadget.$(
			'selTime3Min_' + time3List[1]
		)
		var selTime3SecItem = aaoh.kaze.Gadget.$(
			'selTime3Sec_' + time3List[2]
		)
		aaoh.kaze.Element.setSelected(selTime3HourItem, true);
		aaoh.kaze.Element.setSelected(selTime3MinItem, true);
		aaoh.kaze.Element.setSelected(selTime3SecItem, true);

		// isAlert
		var cbxAlert = aaoh.kaze.Gadget.$('cbxAlert');
		aaoh.kaze.Element.setChecked(
			cbxAlert, aaoh.sora.App.model.data.isAlert
		);

		// isAlertDef
		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		aaoh.kaze.Element.setChecked(
			cbxAlertDef, aaoh.sora.App.model.data.isAlertDef
		);

		// alertMsg
		var txtAlert = aaoh.kaze.Gadget.$('txtAlert');
		if (aaoh.sora.App.model.data.isAlertDef) {
			aaoh.kaze.Element.setValue(
				txtAlert, aaoh.sora.App.control.DEFAULT_ALERT_MSG
			);

		} else {
			aaoh.kaze.Element.setValue(
				txtAlert, aaoh.sora.App.model.data.alertMsg
			);
		}

		// isSound
		var cbxSound = aaoh.kaze.Gadget.$('cbxSound');
		aaoh.kaze.Element.setChecked(
			cbxSound, aaoh.sora.App.model.data.isSound
		);

		// isSoundDef
		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		aaoh.kaze.Element.setChecked(
			cbxSoundDef, aaoh.sora.App.model.data.isSoundDef
		);

		// soundFile
		var txtSound = aaoh.kaze.Gadget.$('txtSound');
		if (aaoh.sora.App.model.data.isSoundDef) {
			var soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;
			aaoh.kaze.Element.setValue(txtSound, soundFile);

		} else {
			aaoh.kaze.Element.setValue(
				txtSound, aaoh.sora.App.model.data.soundFile
			);
		}

		// numSoundVol
		var selSoundVolItem = aaoh.kaze.Gadget.$(
			'selSoundVol_' + aaoh.sora.App.model.data.numSoundVol
		)
		aaoh.kaze.Element.setSelected(selSoundVolItem, true);

		// isAlert
		this.setAlert();

		// isSound
		this.setSound();
	}

	/**
	 * 表示データの初期化(Yahoo)。
	 */
	timer.Option.prototype.
	initDataForYahoo = function() {
		var ttlType      = aaoh.sora.App.control.locale.getString('TTL_TYPE');
		var ttlType1     = aaoh.sora.App.control.locale.getString('TTL_TYPE1');
		var ttlType2     = aaoh.sora.App.control.locale.getString('TTL_TYPE2');
		var ttlType3     = aaoh.sora.App.control.locale.getString('TTL_TYPE3');
		var ttlType4     = aaoh.sora.App.control.locale.getString('TTL_TYPE4');
		var ttlType5     = aaoh.sora.App.control.locale.getString('TTL_TYPE5');
		var ttlType6     = aaoh.sora.App.control.locale.getString('TTL_TYPE6');
		var ttlMode      = aaoh.sora.App.control.locale.getString('TTL_MODE');
		var ttlMode1     = aaoh.sora.App.control.locale.getString('TTL_MODE1');
		var ttlMode2     = aaoh.sora.App.control.locale.getString('TTL_MODE2');
		var ttlTime1Hour = aaoh.sora.App.control.locale.getString('TTL_PRESET1_HOUR');
		var ttlTime1Min  = aaoh.sora.App.control.locale.getString('TTL_PRESET1_MIN');
		var ttlTime1Sec  = aaoh.sora.App.control.locale.getString('TTL_PRESET1_SEC');
		var ttlTime2Hour = aaoh.sora.App.control.locale.getString('TTL_PRESET2_HOUR');
		var ttlTime2Min  = aaoh.sora.App.control.locale.getString('TTL_PRESET2_MIN');
		var ttlTime2Sec  = aaoh.sora.App.control.locale.getString('TTL_PRESET2_SEC');
		var ttlTime3Hour = aaoh.sora.App.control.locale.getString('TTL_PRESET3_HOUR');
		var ttlTime3Min  = aaoh.sora.App.control.locale.getString('TTL_PRESET3_MIN');
		var ttlTime3Sec  = aaoh.sora.App.control.locale.getString('TTL_PRESET3_SEC');
		var ttlAlert     = aaoh.sora.App.control.locale.getString('TTL_ALERT');
		var ttlAlertDef  = aaoh.sora.App.control.locale.getString('TTL_ALERT_DEF');
		var ttlAlertMsg  = aaoh.sora.App.control.locale.getString('TTL_ALERT_MSG');
		var ttlSound     = aaoh.sora.App.control.locale.getString('TTL_SOUND');
		var ttlSoundDef  = aaoh.sora.App.control.locale.getString('TTL_SOUND_DEF');
		var ttlSoundVol  = aaoh.sora.App.control.locale.getString('TTL_SOUND_VOL');
		var ttlSoundFile = aaoh.sora.App.control.locale.getString('TTL_SOUND_FILE');

		// alertMsg
		var alertMsg = null;
		if (aaoh.sora.App.model.data.isAlertDef) {
			alertMsg = aaoh.sora.App.control.DEFAULT_ALERT_MSG;

		} else {
			alertMsg = aaoh.sora.App.model.data.alertMsg;
		}

		var soundFile = null;
		if (aaoh.sora.App.model.data.isSoundDef) {
			soundFile = aaoh.sora.App.control.DEFAULT_SOUND_FILE;

		} else {
			soundFile = aaoh.sora.App.model.data.soundFile;
		}

		preferences.type.title           = ttlType;
		preferences.type.option[0]       = ttlType1;
		preferences.type.option[1]       = ttlType2;
		preferences.type.option[2]       = ttlType3;
		preferences.type.option[3]       = ttlType4;
		preferences.type.option[4]       = ttlType5;
		preferences.type.option[5]       = ttlType6;
		preferences.mode.title           = ttlMode;
		preferences.mode.option[0]       = ttlMode1;
		preferences.mode.option[1]       = ttlMode2;
		preferences.numTime1Hour.title = ttlTime1Hour;
		preferences.numTime1Min.title  = ttlTime1Min;
		preferences.numTime1Sec.title  = ttlTime1Sec;
		preferences.numTime2Hour.title = ttlTime2Hour;
		preferences.numTime2Min.title  = ttlTime2Min;
		preferences.numTime2Sec.title  = ttlTime2Sec;
		preferences.numTime3Hour.title = ttlTime3Hour;
		preferences.numTime3Min.title  = ttlTime3Min;
		preferences.numTime3Sec.title  = ttlTime3Sec;
		preferences.isAlert.title        = ttlAlert;
		preferences.isAlertDef.title     = ttlAlertDef;
		preferences.alertMsg.title       = ttlAlertMsg;
		preferences.alertMsg.value       = alertMsg;
		preferences.isSound.title        = ttlSound;
		preferences.isSoundDef.title     = ttlSoundDef;
		preferences.numSoundVol.title    = ttlSoundVol;
		preferences.soundFile.title      = ttlSoundFile;
		preferences.soundFile.value      = soundFile;
	}

	/**
	 * イベントの設定。
	 */
	timer.Option.prototype.
	setEventListener = function() {
		var cbxAlert = aaoh.kaze.Gadget.$('cbxAlert');
		if (cbxAlert != null) {
			aaoh.kaze.Element.setOnChange(cbxAlert, function() {
				aaoh.sora.App.option.setAlert();
			});
		}

		var cbxAlertDef = aaoh.kaze.Gadget.$('cbxAlertDef');
		if (cbxAlertDef != null) {
			aaoh.kaze.Element.setOnChange(cbxAlertDef, function() {
				aaoh.sora.App.option.setAlertMsg();
			});
		}

		var cbxSound = aaoh.kaze.Gadget.$('cbxSound');
		if (cbxSound != null) {
			aaoh.kaze.Element.setOnChange(cbxSound, function() {
				aaoh.sora.App.option.setSound();
			});
		}

		var cbxSoundDef = aaoh.kaze.Gadget.$('cbxSoundDef');
		if (cbxSoundDef != null) {
			aaoh.kaze.Element.setOnChange(cbxSoundDef, function() {
				aaoh.sora.App.option.setSoundFile();
			});
		}

		var btnSound = aaoh.kaze.Gadget.$('btnSound');
		if (btnSound != null) {
			aaoh.kaze.Element.setOnClick(btnSound, function() {
				aaoh.sora.App.option.browseSoundFile();
			});
		}

		var btnSoundStart = aaoh.kaze.Gadget.$('btnSoundStart');
		if (btnSoundStart != null) {
			aaoh.kaze.Element.setOnClick(btnSoundStart, function() {
				aaoh.sora.App.option.soundPlay();
			});
		}

		var btnSoundStop = aaoh.kaze.Gadget.$('btnSoundStop');
		if (btnSoundStop != null) {
			aaoh.kaze.Element.setOnClick(btnSoundStop, function() {
				aaoh.sora.App.option.soundStop();
			});
		}
	}

	/**
	 * 初期化処理(画面表示)。
	 */
	timer.Option.prototype.
	initDisplay = function() {
		// アラート表示できないときには非表示
		if (!aaoh.kaze.Gadget.isConfirm()) {
			var alertObj = aaoh.kaze.Gadget.$('alert');
			if (alertObj != null) {
				aaoh.kaze.Element.setDisplay(alertObj, false);
			}
		}

		// 音の再生できないときには非表示
		var isSound = aaoh.sora.App.control.sound.isSound();
		if (!isSound) {
			var sound = aaoh.kaze.Gadget.$('sound');
			if (sound != null) {
				aaoh.kaze.Element.setDisplay(sound, false);
			}
		}

		// 音量の設定できないときには非表示
		var isSoundVol = aaoh.sora.App.control.sound.isVolume();
		if (!isSoundVol) {
			var soundVol = aaoh.kaze.Gadget.$('soundVol');
			if (soundVol != null) {
				aaoh.kaze.Element.setDisplay(soundVol, false);
			}
		}
	}

	/**
	 * 初期化処理。
	 */
	timer.Option.prototype.
	init = function() {
		this.setEventListener();
		this.initDisplay();
	}
})();
